# All files / model document_key.ts

95% Statements 19/20
100% Branches 2/2
87.5% Functions 7/8
94.74% Lines 18/19

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71

    2x

    2x

    2x
    10424x
    10424x

    2x
    10117x

    2x
    10648x

    2x

    2x
    148032x

    2x
    18785x

    2x
    109x

    2x

    2x
     /**
     * Copyright 2017 Google Inc.
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *   http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */

    import { assert } from '../util/assert';

    import { ResourcePath } from './path';

    export class DocumentKey {
      constructor(readonly path: ResourcePath) {
        assert(
          DocumentKey.isDocumentKey(path),
          'Invalid DocumentKey with an odd number of segments: ' +
            path.toArray().join('/')
        );
      }

      isEqual(other: DocumentKey | null): boolean {
        return (
          other !== null && ResourcePath.comparator(this.path, other.path) === 0
        );
      }

      toString(): string {
        return this.path.toString();
      }

      static EMPTY = new DocumentKey(new ResourcePath([]));

      static comparator(k1: DocumentKey, k2: DocumentKey): number {
        return ResourcePath.comparator(k1.path, k2.path);
      }

      static isDocumentKey(path: ResourcePath): boolean {
        return path.length % 2 === 0;
      }

      /**
       * Creates and returns a new document key with the given segments.
       *
       * @param path The segments of the path to the document
       * @return A new instance of DocumentKey
       */
      static fromSegments(segments: string[]): DocumentKey {
        return new DocumentKey(new ResourcePath(segments.slice()));
      }

      /**
       * Creates and returns a new document key using '/' to split the string into
       * segments.
       *
       * @param path The slash-separated path string to the document
       * @return A new instance of DocumentKey
       */
      static fromPathString(path: string): DocumentKey {
        return new DocumentKey(ResourcePath.fromString(path));
      }
    }